/* WINS.C
 * Funzioni per gestione finestre video */

#include	<conio.h>
#include	<bios.h>
#include	<string.h>
#include	"wins.h"

struct	text_info	wins [10];
int    	curwin;

void NewWin (int i,int frame,int left,int top,int right,int bottom,char *title)
{
	if (frame) Frame (left,top,right,bottom,title);

	window (left,top,right,bottom);
	clrscr ();
	curwin = i;
	gettextinfo (wins + curwin);
}

void Frame (int left,int top,int right,int bottom,char *title)
{
int n;
	textattr (0xf);
	if (left < 2) left = 2;
	if (right > 79) right = 79;
	if (top < 2) top = 2;
	if (bottom > 23) bottom = 23;

	window (1,1,80,25);
	gotoxy (left - 1,top - 1);
	putch (DUL);
	for (n = left;n <= right;n ++) putch (DHOR);
	putch (DUR);
	for (n = top;n <= bottom;n ++)
	{
		gotoxy (left - 1,n);
		putch (DVERT);
		gotoxy (right + 1,n);
		putch (DVERT);
	}
	gotoxy (left - 1,bottom + 1);
	putch (DLL);
	for (n = left;n <= right;n ++) putch (DHOR);
	putch (DLR);

	if (title)
	{
	char t [80];

		strcpy (t,title);
		t [right - left] = 0;	// trunctes title to max window width
		gotoxy ((left + right - strlen (t)) / 2,top - 1);
		cprintf ("%s",t);
	}
}

void SelectWin (int i)
{
	gettextinfo (wins + curwin);
	curwin = i;
	window (wins [i].winleft,wins [i].wintop,wins [i].winright,
		wins [i].winbottom);
	textattr (wins [i].attribute);
	gotoxy (wins [i].curx,wins [i].cury);
}

int Key (void)
{
int	key;
	key = bioskey (0);
	if (key & 0xff) key &= 0xff;
	return (key);
}
